<?php
/**
 * Wizard
 *
 * @package Omega_Design_Agency_Whizzie
 * @author Catapult Themes
 * @since 1.0.0
 */

class Omega_Design_Agency_Whizzie {
	
	protected $version = '1.1.0';
	
	/** @var string Current theme name, used as namespace in actions. */
	protected $omega_design_agency_theme_name = '';
	protected $omega_design_agency_theme_title = '';
	
	/** @var string Wizard page slug and title. */
	protected $omega_design_agency_page_slug = '';
	protected $omega_design_agency_page_title = '';
	
	/** @var array Wizard steps set by user. */
	protected $config_steps = array();
	
	public $parent_slug;
	
	/**
	 * Constructor
	 *
	 * @param $config	Our config parameters
	 */
	public function __construct( $config ) {
		$this->set_vars( $config );
		$this->init();
	}
	
	/**
	 * Set some settings
	 * @since 1.0.0
	 * @param $config	Our config parameters
	 */
	public function set_vars( $config ) {

		if( isset( $config['omega_design_agency_page_slug'] ) ) {
			$this->omega_design_agency_page_slug = esc_attr( $config['omega_design_agency_page_slug'] );
		}
		if( isset( $config['omega_design_agency_page_title'] ) ) {
			$this->omega_design_agency_page_title = esc_attr( $config['omega_design_agency_page_title'] );
		}
		if( isset( $config['steps'] ) ) {
			$this->config_steps = $config['steps'];
		}

		$omega_design_agency_current_theme = wp_get_theme();
		$this->omega_design_agency_theme_title = $omega_design_agency_current_theme->get( 'Name' );
		$this->omega_design_agency_theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $omega_design_agency_current_theme->get( 'Name' ) ) );
		$this->omega_design_agency_page_slug = apply_filters( $this->omega_design_agency_theme_name . '_theme_setup_wizard_omega_design_agency_page_slug', $this->omega_design_agency_theme_name . '-wizard' );
		$this->parent_slug = apply_filters( $this->omega_design_agency_theme_name . '_theme_setup_wizard_parent_slug', '' );

	}
	
	/**
	 * Hooks and filters
	 * @since 1.0.0
	 */	
	public function init() {

		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'wp_ajax_omega_design_agency_setup_widgets', array( $this, 'omega_design_agency_setup_widgets' ) );
		
	}
	
	public function enqueue_scripts() {
		wp_enqueue_style( 'omega-design-agency-homepage-setup-style', get_template_directory_uri() . '/inc/homepage-setup/assets/css/homepage-setup-style.css');
		wp_register_script( 'omega-design-agency-homepage-setup-script', get_template_directory_uri() . '/inc/homepage-setup/assets/js/homepage-setup-script.js', array( 'jquery' ), time() );
		wp_localize_script( 
			'omega-design-agency-homepage-setup-script',
			'whizzie_params',
			array(
				'ajaxurl' 		=> admin_url( 'admin-ajax.php' ),
				'wpnonce' 		=> wp_create_nonce( 'whizzie_nonce' ),
				'verify_text'	=> esc_html( 'verifying', 'omega-design-agency' )
			)
		);
		wp_enqueue_script( 'omega-design-agency-homepage-setup-script' );
	}
	
	public static function get_instance() {
		if ( ! self::$instance ) {
			self::$instance = new self;
		}
		return self::$instance;
	}
	
	/**
	 * Make a modal screen for the wizard
	 */
	public function menu_page() {
		add_theme_page( esc_html( $this->omega_design_agency_page_title ), esc_html( $this->omega_design_agency_page_title ), 'manage_options', $this->omega_design_agency_page_slug, array( $this, 'wizard_page' ) );
	}
	
	/**
	 * Make an interface for the wizard
	 */
	public function wizard_page() {

		$url = wp_nonce_url( add_query_arg( array( 'plugins' => 'go' ) ), 'whizzie-setup' );
		$method = '';
		$fields = array_keys( $_POST );

		if ( false === ( $creds = request_filesystem_credentials( esc_url_raw( $url ), $method, false, false, $fields ) ) ) {
			return true;
		}

		if ( ! WP_Filesystem( $creds ) ) {
			request_filesystem_credentials( esc_url_raw( $url ), $method, true, false, $fields );
			return true;
		}

		$omega_design_agency_theme = wp_get_theme();
		$omega_design_agency_theme_title = $omega_design_agency_theme->get( 'Name' );
		$omega_design_agency_theme_version = $omega_design_agency_theme->get( 'Version' );

		?>
		<div class="wrap">
			<?php
				printf( '<h1>%s %s</h1>', esc_html( $omega_design_agency_theme_title ), esc_html( '(Version :- ' . $omega_design_agency_theme_version . ')' ) );
			?>
			<div class="homepage-setup">
				<div class="homepage-setup-theme-bundle">
					<div class="homepage-setup-theme-bundle-one">
						<h1><?php echo esc_html__( 'WP Theme Bundle', 'omega-design-agency' ); ?></h1>
						<p><?php echo wp_kses_post( 'Get <span>15% OFF</span> on all WordPress themes! Use code <span>"BNDL15OFF"</span> at checkout. Limited time offer!' ); ?></p>
					</div>
					<div class="homepage-setup-theme-bundle-two">
						<p><?php echo wp_kses_post( 'Extra <span>15%</span> OFF' ); ?></p>
					</div>
					<div class="homepage-setup-theme-bundle-three">
						<img src="<?php echo esc_url( get_template_directory_uri() . '/inc/homepage-setup/assets/homepage-setup-images/bundle-banner.png' ); ?>" alt="<?php echo esc_attr__( 'Theme Bundle Image', 'omega-design-agency' ); ?>">
					</div>
					<div class="homepage-setup-theme-bundle-four">
						<p><?php echo wp_kses_post( '<span>$2795</span>$69' ); ?></p>
						<a target="_blank" href="<?php echo esc_url( OMEGA_DESIGN_AGENCY_BUNDLE_BUTTON ); ?>"><?php echo esc_html__( 'SHOP NOW', 'omega-design-agency' ); ?> <span class="dashicons dashicons-arrow-right-alt2"></span></a>
					</div>
				</div>
			</div>
			
			<div class="card whizzie-wrap">
				<div class="demo_content_image">
					<div class="demo_content">
						<?php
							$omega_design_agency_steps = $this->get_steps();
							echo '<ul class="whizzie-menu">';
							foreach ( $omega_design_agency_steps as $omega_design_agency_step ) {
								$class = 'step step-' . esc_attr( $omega_design_agency_step['id'] );
								echo '<li data-step="' . esc_attr( $omega_design_agency_step['id'] ) . '" class="' . esc_attr( $class ) . '">';
								printf( '<h2>%s</h2>', esc_html( $omega_design_agency_step['title'] ) );

								$content = call_user_func( array( $this, $omega_design_agency_step['view'] ) );
								if ( isset( $content['summary'] ) ) {
									printf(
										'<div class="summary">%s</div>',
										wp_kses_post( $content['summary'] )
									);
								}
								if ( isset( $content['detail'] ) ) {
									printf(
										'<div class="detail">%s</div>',
										wp_kses_post( $content['detail'] )
									);
								}
								if ( isset( $omega_design_agency_step['button_text'] ) && $omega_design_agency_step['button_text'] ) {
									printf( 
										'<div class="button-wrap"><a href="#" class="button button-primary do-it" data-callback="%s" data-step="%s">%s</a></div>',
										esc_attr( $omega_design_agency_step['callback'] ),
										esc_attr( $omega_design_agency_step['id'] ),
										esc_html( $omega_design_agency_step['button_text'] )
									);
								}
								echo '</li>';
							}
							echo '</ul>';
						?>
						
						<ul class="whizzie-nav">
							<?php
							$step_number = 1;	
							foreach ( $omega_design_agency_steps as $omega_design_agency_step ) {
								echo '<li class="nav-step-' . esc_attr( $omega_design_agency_step['id'] ) . '">';
								echo '<span class="step-number">' . esc_html( $step_number ) . '</span>';
								echo '</li>';
								$step_number++;
							}
							?>
							<div class="blank-border"></div>
						</ul>

						<div class="homepage-setup-links">
							<div class="homepage-setup-links buttons">
								<a href="<?php echo esc_url( OMEGA_DESIGN_AGENCY_LITE_DOCS_PRO ); ?>" target="_blank" class="button button-primary"><?php echo esc_html__( 'Free Documentation', 'omega-design-agency' ); ?></a>
								<a href="<?php echo esc_url( OMEGA_DESIGN_AGENCY_BUY_NOW ); ?>" class="button button-primary" target="_blank"><?php echo esc_html__( 'Get Premium', 'omega-design-agency' ); ?></a>
								<a href="<?php echo esc_url( OMEGA_DESIGN_AGENCY_DEMO_PRO ); ?>" class="button button-primary" target="_blank"><?php echo esc_html__( 'Premium Demo', 'omega-design-agency' ); ?></a>
								<a href="<?php echo esc_url( OMEGA_DESIGN_AGENCY_SUPPORT_FREE ); ?>" target="_blank" class="button button-primary"><?php echo esc_html__( 'Support Forum', 'omega-design-agency' ); ?></a>
							</div>
						</div> <!-- .demo_image -->

						<div class="step-loading"><span class="spinner"></span></div>
					</div> <!-- .demo_content -->

					<div class="homepage-setup-image">
						<div class="homepage-setup-theme-buynow">
							<div class="homepage-setup-theme-buynow-one">
								<h1><?php echo wp_kses_post( 'Designer Agency<br>WordPress Theme' ); ?></h1>
								<p><?php echo wp_kses_post( '<span>25%<br>Off</span> SHOP NOW' ); ?></p>
							</div>
							<div class="homepage-setup-theme-buynow-two">
								<img src="<?php echo esc_url( get_template_directory_uri() . '/inc/homepage-setup/assets/homepage-setup-images/omega-design-agency.png' ); ?>" alt="<?php echo esc_attr__( 'Theme Bundle Image', 'omega-design-agency' ); ?>">
							</div>
							<div class="homepage-setup-theme-buynow-three">
								<p><?php echo wp_kses_post( 'Get <span>25% OFF</span> on Premium Designer Agency WordPress Theme Use code <span>"NYTHEMES25"</span> at checkout.' ); ?></p>
							</div>
							<div class="homepage-setup-theme-buynow-four">
								<a target="_blank" href="<?php echo esc_url( OMEGA_DESIGN_AGENCY_BUY_NOW ); ?>"><?php echo esc_html__( 'Upgrade To Pro With Just $40', 'omega-design-agency' ); ?></a>
							</div>
						</div>
					</div> <!-- .demo_image -->

				</div> <!-- .demo_content_image -->
			</div> <!-- .whizzie-wrap -->
		</div> <!-- .wrap -->
		<?php
	}


	/**
	 * Set options for the steps
	 * Incorporate any options set by the theme dev
	 * Return the array for the steps
	 * @return Array
	 */
	public function get_steps() {
		$omega_design_agency_dev_steps = $this->config_steps;
		$omega_design_agency_steps = array(
			'widgets' => array(
				'id'			=> 'widgets',
				'title'			=> __( 'Setup Home Page', 'omega-design-agency' ),
				'icon'			=> 'welcome-widgets-menus',
				'view'			=> 'get_step_widgets',
				'callback'		=> 'omega_design_agency_install_widgets',
				'button_text'	=> __( 'Start Home Page Setup', 'omega-design-agency' ),
				'can_skip'		=> false
			),
			'done' => array(
				'id'			=> 'done',
				'title'			=> __( 'Customize Your Site', 'omega-design-agency' ),
				'icon'			=> 'yes',
				'view'			=> 'get_step_done',
				'callback'		=> ''
			)
		);
		
		// Iterate through each step and replace with dev config values
		if( $omega_design_agency_dev_steps ) {
			// Configurable elements - these are the only ones the dev can update from homepage-setup-settings.php
			$can_config = array( 'title', 'icon', 'button_text', 'can_skip' );
			foreach( $omega_design_agency_dev_steps as $omega_design_agency_dev_step ) {
				// We can only proceed if an ID exists and matches one of our IDs
				if( isset( $omega_design_agency_dev_step['id'] ) ) {
					$id = $omega_design_agency_dev_step['id'];
					if( isset( $omega_design_agency_steps[$id] ) ) {
						foreach( $can_config as $element ) {
							if( isset( $omega_design_agency_dev_step[$element] ) ) {
								$omega_design_agency_steps[$id][$element] = $omega_design_agency_dev_step[$element];
							}
						}
					}
				}
			}
		}
		return $omega_design_agency_steps;
	}
	
	/**
	 * Print the content for the widgets step
	 * @since 1.1.0
	 */
	public function get_step_widgets() { ?> <?php }
	
	/**
	 * Print the content for the final step
	 */
	public function get_step_done() { ?>
		<div id="omega-design-agency-demo-setup-guid">
			<div class="customize_div">
				<div class="customize_div finish">
					<div class="customize_div finish btns">
						<h3><?php echo esc_html( 'Your Site Is Ready To View' ); ?></h3>
						<div class="btnsss">
							<a target="_blank" href="<?php echo esc_url( get_home_url() ); ?>" class="button button-primary">
								<?php esc_html_e( 'View Your Site', 'omega-design-agency' ); ?>
							</a>
							<a target="_blank" href="<?php echo esc_url( admin_url( 'customize.php' ) ); ?>" class="button button-primary">
								<?php esc_html_e( 'Customize Your Site', 'omega-design-agency' ); ?>
							</a>
							<a href="<?php echo esc_url(admin_url()); ?>" class="button button-primary">
								<?php esc_html_e( 'Finsh', 'omega-design-agency' ); ?>
							</a>
						</div>
					</div>
					<div class="omega-design-agency-setup-finish">
						<img src="<?php echo esc_url( get_template_directory_uri() . '/screenshot.png' ); ?>"/>
					</div>
				</div>
			</div>
		</div>
	<?php }


	public function omega_design_agency_customizer_nav_menu() {

		/* -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- Omega Design Agency Primary Menu -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-*/

		$omega_design_agency_themename = 'Omega Design Agency';
		$omega_design_agency_menuname = $omega_design_agency_themename . ' Primary Menu';
		$omega_design_agency_menulocation = 'omega-design-agency-primary-menu';
		$omega_design_agency_menu_exists = wp_get_nav_menu_object($omega_design_agency_menuname);

		if (!$omega_design_agency_menu_exists) {
			$omega_design_agency_menu_id = wp_create_nav_menu($omega_design_agency_menuname);

			// Home
			wp_update_nav_menu_item($omega_design_agency_menu_id, 0, array(
				'menu-item-title' => __('Home', 'omega-design-agency'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));

			// About
			$omega_design_agency_page_about = get_page_by_path('about');
			if($omega_design_agency_page_about){
				wp_update_nav_menu_item($omega_design_agency_menu_id, 0, array(
					'menu-item-title' => __('About', 'omega-design-agency'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($omega_design_agency_page_about),
					'menu-item-status' => 'publish'
				));
			}

			// Services
			$omega_design_agency_page_services = get_page_by_path('services');
			if($omega_design_agency_page_services){
				wp_update_nav_menu_item($omega_design_agency_menu_id, 0, array(
					'menu-item-title' => __('Services', 'omega-design-agency'),
					'menu-item-classes' => 'services',
					'menu-item-url' => get_permalink($omega_design_agency_page_services),
					'menu-item-status' => 'publish'
				));
			}

			// Shop Page (WooCommerce)
			if (class_exists('WooCommerce')) {
				$omega_design_agency_shop_page_id = wc_get_page_id('shop');
				if ($omega_design_agency_shop_page_id) {
					wp_update_nav_menu_item($omega_design_agency_menu_id, 0, array(
						'menu-item-title' => __('Shop', 'omega-design-agency'),
						'menu-item-classes' => 'shop',
						'menu-item-url' => get_permalink($omega_design_agency_shop_page_id),
						'menu-item-status' => 'publish'
					));
				}
			}

			// Blog
			$omega_design_agency_page_blog = get_page_by_path('blog');
			if($omega_design_agency_page_blog){
				wp_update_nav_menu_item($omega_design_agency_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'omega-design-agency'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($omega_design_agency_page_blog),
					'menu-item-status' => 'publish'
				));
			}

			// 404 Page
			$omega_design_agency_notfound = get_page_by_path('404 Page');
			if($omega_design_agency_notfound){
				wp_update_nav_menu_item($omega_design_agency_menu_id, 0, array(
					'menu-item-title' => __('404 Page', 'omega-design-agency'),
					'menu-item-classes' => '404',
					'menu-item-url' => get_permalink($omega_design_agency_notfound),
					'menu-item-status' => 'publish'
				));
			}

			if (!has_nav_menu($omega_design_agency_menulocation)) {
				$omega_design_agency_locations = get_theme_mod('nav_menu_locations');
				$omega_design_agency_locations[$omega_design_agency_menulocation] = $omega_design_agency_menu_id;
				set_theme_mod('nav_menu_locations', $omega_design_agency_locations);
			}
		}
	}

	
	/**
	 * Imports the Demo Content
	 * @since 1.1.0
	 */
	public function omega_design_agency_setup_widgets(){

		/* -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- MENUS PAGES -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-*/
		
			// Creation of home page //
			$omega_design_agency_home_content = '';
			$omega_design_agency_home_title = 'Home';
			$omega_design_agency_home = array(
					'post_type' => 'page',
					'post_title' => $omega_design_agency_home_title,
					'post_content'  => $omega_design_agency_home_content,
					'post_status' => 'publish',
					'post_author' => 1,
					'post_slug' => 'home'
			);
			$omega_design_agency_home_id = wp_insert_post($omega_design_agency_home);

			add_post_meta( $omega_design_agency_home_id, '_wp_page_template', 'frontpage.php' );

			$omega_design_agency_home = get_page_by_path( 'Home' );
			update_option( 'page_on_front', $omega_design_agency_home->ID );
			update_option( 'show_on_front', 'page' );

			// Creation of blog page //
			$omega_design_agency_blog_title = 'Blog';
			$omega_design_agency_blog_check = get_page_by_path('blog');
			if (!$omega_design_agency_blog_check) {
				$omega_design_agency_blog = array(
					'post_type'    => 'page',
					'post_title'   => $omega_design_agency_blog_title,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'blog'
				);
				$omega_design_agency_blog_id = wp_insert_post($omega_design_agency_blog);

				if (!is_wp_error($omega_design_agency_blog_id)) {
					update_option('page_for_posts', $omega_design_agency_blog_id);
				}
			}

			// Creation of about page //
			$omega_design_agency_about_title = 'About';
			$omega_design_agency_about_content = 'What is Lorem Ipsum?
														Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industrys standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.
														&nbsp;
														Why do we use it?
														It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using Content here, content here, making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for lorem ipsum will uncover many web sites still in their infancy. Various versions have evolved over the years, sometimes by accident, sometimes on purpose (injected humour and the like).
														&nbsp;
														Where does it come from?
														There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which dont look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isnt anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.
														&nbsp;
														Why do we use it?
														It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using Content here, content here, making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for lorem ipsum will uncover many web sites still in their infancy. Various versions have evolved over the years, sometimes by accident, sometimes on purpose (injected humour and the like).
														&nbsp;
														Where does it come from?
														There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which dont look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isnt anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.';
			$omega_design_agency_about_check = get_page_by_path('about');
			if (!$omega_design_agency_about_check) {
				$omega_design_agency_about = array(
					'post_type'    => 'page',
					'post_title'   => $omega_design_agency_about_title,
					'post_content'   => $omega_design_agency_about_content,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'about'
				);
				wp_insert_post($omega_design_agency_about);
			}

			// Creation of services page //
			$omega_design_agency_services_title = 'Services';
			$omega_design_agency_services_content = 'What is Lorem Ipsum?
														Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industrys standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.
														&nbsp;
														Why do we use it?
														It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using Content here, content here, making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for lorem ipsum will uncover many web sites still in their infancy. Various versions have evolved over the years, sometimes by accident, sometimes on purpose (injected humour and the like).
														&nbsp;
														Where does it come from?
														There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which dont look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isnt anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.
														&nbsp;
														Why do we use it?
														It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using Content here, content here, making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for lorem ipsum will uncover many web sites still in their infancy. Various versions have evolved over the years, sometimes by accident, sometimes on purpose (injected humour and the like).
														&nbsp;
														Where does it come from?
														There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which dont look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isnt anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.';
			$omega_design_agency_services_check = get_page_by_path('services');
			if (!$omega_design_agency_services_check) {
				$omega_design_agency_services = array(
					'post_type'    => 'page',
					'post_title'   => $omega_design_agency_services_title,
					'post_content'   => $omega_design_agency_services_content,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'services'
				);
				wp_insert_post($omega_design_agency_services);
			}

			// Creation of 404 page //
			$omega_design_agency_notfound_title = '404 Page';
			$omega_design_agency_notfound = array(
				'post_type'   => 'page',
				'post_title'  => $omega_design_agency_notfound_title,
				'post_status' => 'publish',
				'post_author' => 1,
				'post_slug'   => '404'
			);
			$omega_design_agency_notfound_id = wp_insert_post($omega_design_agency_notfound);
			add_post_meta($omega_design_agency_notfound_id, '_wp_page_template', '404.php');


		/* -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- SLIDER POST -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-*/

			$omega_design_agency_slider_title = array('Create A Winning Brand With Our Agency\'s Strategy & Creativity!');
			for($omega_design_agency_i=1;$omega_design_agency_i<=1;$omega_design_agency_i++){

				$omega_design_agency_title = $omega_design_agency_slider_title[$omega_design_agency_i-1];
				$omega_design_agency_content = 'lorem ipsum content.';

				// Create post object
				$omega_design_agency_my_post = array(
						'post_title'    => wp_strip_all_tags( $omega_design_agency_title ),
						'post_content'  => $omega_design_agency_content,
						'post_status'   => 'publish',
						'post_type'     => 'post',
				);
				// Insert the post into the database
				$omega_design_agency_post_id = wp_insert_post( $omega_design_agency_my_post );

				wp_set_object_terms($omega_design_agency_post_id, 'Slider', 'category', true);

				wp_set_object_terms($omega_design_agency_post_id, 'Slider', 'post_tag', true);

				$omega_design_agency_image_url = get_template_directory_uri().'/inc/homepage-setup/assets/homepage-setup-images/slider-img'.$omega_design_agency_i.'.png';

				$omega_design_agency_image_name= 'slider-img'.$omega_design_agency_i.'.png';
				$upload_dir       = wp_upload_dir();
				// Set upload folder
				$omega_design_agency_image_data       = file_get_contents($omega_design_agency_image_url);
				// Get image data
				$unique_file_name = wp_unique_filename( $upload_dir['path'], $omega_design_agency_image_name );

				$omega_design_agency_filename = basename( $unique_file_name ); 
				
				// Check folder permission and define file location
				if( wp_mkdir_p( $upload_dir['path'] ) ) {
						$omega_design_agency_file = $upload_dir['path'] . '/' . $omega_design_agency_filename;
				} else {
						$omega_design_agency_file = $upload_dir['basedir'] . '/' . $omega_design_agency_filename;
				}
				// Create the image  file on the server
				// Generate unique name
				if ( ! function_exists( 'WP_Filesystem' ) ) {
					require_once( ABSPATH . 'wp-admin/includes/file.php' );
				}
				
				WP_Filesystem();
				global $wp_filesystem;
				
				if ( ! $wp_filesystem->put_contents( $omega_design_agency_file, $omega_design_agency_image_data, FS_CHMOD_FILE ) ) {
					wp_die( 'Error saving file!' );
				}
				// Check image file type
				$wp_filetype = wp_check_filetype( $omega_design_agency_filename, null );
				// Set attachment data
				$omega_design_agency_attachment = array(
						'post_mime_type' => $wp_filetype['type'],
						'post_title'     => sanitize_file_name( $omega_design_agency_filename ),
						'post_content'   => '',
						'post_type'     => 'post',
						'post_status'    => 'inherit'
				);
				// Create the attachment
				$omega_design_agency_attach_id = wp_insert_attachment( $omega_design_agency_attachment, $omega_design_agency_file, $omega_design_agency_post_id );
				// Include image.php
				require_once(ABSPATH . 'wp-admin/includes/image.php');
				// Define attachment metadata
				$omega_design_agency_attach_data = wp_generate_attachment_metadata( $omega_design_agency_attach_id, $omega_design_agency_file );
				// Assign metadata to attachment
					wp_update_attachment_metadata( $omega_design_agency_attach_id, $omega_design_agency_attach_data );
				// And finally assign featured image to post
				set_post_thumbnail( $omega_design_agency_post_id, $omega_design_agency_attach_id );

			}

			/* -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- SECOND SECTION POST -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-*/

				$omega_design_agency_second_section_title = array('Yu R. Craighead','David J. Banker','April G. Kozlowsk');
				for($omega_design_agency_i=1;$omega_design_agency_i<=3;$omega_design_agency_i++){

					$omega_design_agency_title = $omega_design_agency_second_section_title[$omega_design_agency_i-1];
					$omega_design_agency_content = 'lorem ipsum content.';

					// Create post object
					$omega_design_agency_my_post = array(
							'post_title'    => wp_strip_all_tags( $omega_design_agency_title ),
							'post_content'  => $omega_design_agency_content,
							'post_status'   => 'publish',
							'post_type'     => 'post',
					);
						// Insert the post into the database
					$omega_design_agency_post_id = wp_insert_post( $omega_design_agency_my_post );

					wp_set_object_terms($omega_design_agency_post_id, 'Second', 'category', true);

					wp_set_object_terms($omega_design_agency_post_id, 'Second', 'post_tag', true);

					$omega_design_agency_image_url = get_template_directory_uri().'/inc/homepage-setup/assets/homepage-setup-images/post-img'.$omega_design_agency_i.'.png';

					$omega_design_agency_image_name= 'post-img'.$omega_design_agency_i.'.png';
					$upload_dir       = wp_upload_dir();
					// Set upload folder
					$omega_design_agency_image_data       = file_get_contents($omega_design_agency_image_url);
					// Get image data
					$unique_file_name = wp_unique_filename( $upload_dir['path'], $omega_design_agency_image_name );

					$omega_design_agency_filename = basename( $unique_file_name ); 
					
					// Check folder permission and define file location
					if( wp_mkdir_p( $upload_dir['path'] ) ) {
							$omega_design_agency_file = $upload_dir['path'] . '/' . $omega_design_agency_filename;
					} else {
							$omega_design_agency_file = $upload_dir['basedir'] . '/' . $omega_design_agency_filename;
					}
					// Create the image  file on the server
					// Generate unique name
					if ( ! function_exists( 'WP_Filesystem' ) ) {
						require_once( ABSPATH . 'wp-admin/includes/file.php' );
					}
					
					WP_Filesystem();
					global $wp_filesystem;
					
					if ( ! $wp_filesystem->put_contents( $omega_design_agency_file, $omega_design_agency_image_data, FS_CHMOD_FILE ) ) {
						wp_die( 'Error saving file!' );
					}
					// Check image file type
					$wp_filetype = wp_check_filetype( $omega_design_agency_filename, null );
					// Set attachment data
					$omega_design_agency_attachment = array(
							'post_mime_type' => $wp_filetype['type'],
							'post_title'     => sanitize_file_name( $omega_design_agency_filename ),
							'post_content'   => '',
							'post_type'     => 'post',
							'post_status'    => 'inherit'
					);
					// Create the attachment
					$omega_design_agency_attach_id = wp_insert_attachment( $omega_design_agency_attachment, $omega_design_agency_file, $omega_design_agency_post_id );
					// Include image.php
					require_once(ABSPATH . 'wp-admin/includes/image.php');
					// Define attachment metadata
					$omega_design_agency_attach_data = wp_generate_attachment_metadata( $omega_design_agency_attach_id, $omega_design_agency_file );
					// Assign metadata to attachment
						wp_update_attachment_metadata( $omega_design_agency_attach_id, $omega_design_agency_attach_data );
					// And finally assign featured image to post
					set_post_thumbnail( $omega_design_agency_post_id, $omega_design_agency_attach_id );

				}


        
        $this->omega_design_agency_customizer_nav_menu();

	    exit;
	}
}